<?php

// $Id: a_attach.php,v 1.6 2010/09/09 06:51:35 calicant Exp $

require_once "../../../adm/lib/setup.php";
require PRISCILLA_LOCAL_PATH . "adm/lib/test_auth.php";
require PRISCILLA_LOCAL_PATH . "modules/core/lib/attach_config.inc.php";

require_once PRISCILLA_LOCAL_PATH . "tools/lang/$lang/dialog.diz";
require_once PRISCILLA_LOCAL_PATH . "tools/lang/$lang/error.diz";

set_time_limit(0);

$debug = 0;

define('DEFAULT_ATTACH_GROUP', '');
define('ATTACH_TABLE_NAME', 'allegati');
define('ATTACH_FIELD_ID', 'id_allegato');
define('ATTACH_FIELD_CODE', 'code');
define('ATTACH_MAX_NAME_LENGTH', 61);

$attach_title = array (
    T_DOCS => dialog_doc_tt_ins, 
    T_ARCHIVE => dialog_arc_tt_ins, 
    T_AUDIO => dialog_aud_tt_ins,
    T_VIDEO => dialog_vid_tt_ins
);


function randuid ($count) {

    srand((float) microtime() * 10000000);
    $chars = array_merge(range('a','z'), range('A','Z'), range('0','9'));
    $indices = array_rand($chars, $count);

    $result = "";
    foreach ($indices as $index)
    $result .= $chars[$index];

return $result;
} // randuid


function generate_new_code ($connh, $tablename, $idf, $codef) {

    // ci proviamo 10 volte
    $goodcode = '';        

    for ($i = 0; $i < 10; $i++) {
    $tempcode = randuid(5);
    
    $dbquery =
        "SELECT $idf FROM $tablename WHERE $codef = '$tempcode'";
    $rowrs = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $connh->ErrorMsg());

    if ($rowrs->RecordCount() == 0) {
        $goodcode = $tempcode;
        break;
    }
    }

return $goodcode;
} // generate_new_code

function is_a_good_groupname ($filename) {
        if (!(ereg("^([[:alnum:]_]{1,})$", $filename)))
                return 0;
        else return 1;
}

function output_select_group ($name, $currv, $login, $connh, $tipoallegato) {


    if ($name == 'attach_select')
    $ifchange = "onchange=\"document.forms.fopzioni.submit();\"";
    else
    $ifchange = '';

    echo
    "<select class=\"insert_area\" name=\"$name\" size=\"1\" $ifchange>\n" .
    "<option value=\"\">".dialog_att_group_none."</option>\n";

    $dbquery =
    "SELECT DISTINCT gruppo FROM ". ATTACH_TABLE_NAME . " WHERE id_user = '".$_COOKIE['login']."' AND tipo = '$tipoallegato' ORDER BY gruppo ASC";
    $rowrs = $connh->Execute($dbquery) or die("ERROR:$dbquery<br />".$connh->ErrorMsg());
    
    if ($rowrs->RecordCount() > 0) {
    while (!$rowrs->EOF) {
        $row = $rowrs->fields;
        $is_selected = $row[gruppo] == $currv ? "SELECTED" : '';
        if (trim($row[gruppo]) != '')
        echo "<option $is_selected value=\"$row[gruppo]\">$row[gruppo]</option>\n";
            $rowrs->MoveNext();
        }
    }

    echo "</select>\n";

}

if (isset($_GET['at']) && in_array($_GET['at'], $attach_list)) {
    if ($PRISCILLA_SESSION->exists('attach_type'));
    $PRISCILLA_SESSION->remove('attach_type');
    $PRISCILLA_SESSION->add('attach_type', $_GET['at']);
    $PRISCILLA_SESSION->add('attach_group', DEFAULT_ATTACH_GROUP);
    $tipoallegato =  $PRISCILLA_SESSION->getvalue('attach_type');
}

if (isset($_POST['attach_select'])) {
    if ($PRISCILLA_SESSION->exists('attach_group'));
    $PRISCILLA_SESSION->remove('attach_group');
    $PRISCILLA_SESSION->add('attach_group', $_POST['attach_select']);
}

if (isset($_POST['attach_group'])) {
    if ($PRISCILLA_SESSION->exists('attach_group'));
    $PRISCILLA_SESSION->remove('attach_group');
    $PRISCILLA_SESSION->add('attach_group', $_POST['attach_group']);
}

// un default per il gruppo di allegati
if (!$PRISCILLA_SESSION->exists('attach_group'))
    $PRISCILLA_SESSION->add('attach_group', DEFAULT_ATTACH_GROUP);


if ($PRISCILLA_SESSION->exists('attach_type'))
    $tipoallegato = $PRISCILLA_SESSION->getvalue('attach_type');

// si setta un default
if (!in_array($tipoallegato, $attach_list)) {
    $tipoallegato = T_DOCS;
    $PRISCILLA_SESSION->add('attach_type', $tipoallegato);
}
    
// creazione di un nuovo gruppo

$group_error = false;


if (isset($upattachfile) && trim($upattachfile) != '' &&
    isset($_POST['create_new_group']) && trim($_POST['create_new_group']) != '') {

    if ($debug)
    echo "create group " . $_POST['create_new_group'] . "<br />";

    if (!is_a_good_groupname($_POST['create_new_group']))
    $group_error = true;
    else {
    $PRISCILLA_SESSION->add('attach_group', $_POST['create_new_group']);
    if (!file_exists(PRISCILLA_LOCAL_PATH . "attach/".$_COOKIE['login']."/$tipoallegato/" . $_POST['create_new_group']))
        mkdir (PRISCILLA_LOCAL_PATH . "attach/".$_COOKIE['login']."/$tipoallegato/" . $_POST['create_new_group'], 0700);
    }
}


$attachgroup = $PRISCILLA_SESSION->getvalue('attach_group');


// estraggo i dati dell'utente (per personalizzazioni)
$usertable = $PRISCILLA_SESSION->getvalue('usertable');

if ($usertable[livello] > 2) 
    die("Authentication failed");

if ($usertable[skin] != '') $skin = $usertable[skin];
if ($usertable[lingua] != '') $lang = $usertable[lingua];

// script corrente
$currscript = $_SERVER['PHP_SELF'];


// massima dimensione per questo tipo di allegato
$maxfsize = $attach_size[$tipoallegato];

// estensioni consentite
$attachext = $attach_extension[$tipoallegato];

// directory di destinazione
if (trim($attachgroup != ''))
    $group_part = "/$attachgroup";
else
    $group_part = '';

$predir = PRISCILLA_LOCAL_PATH . "attach/".$_COOKIE['login']."/$tipoallegato" . $group_part;


$maxsize_mb = round($attach_size[$tipoallegato] / (1024 * 1024));

// crea la dir destinazione se non presente
if (!file_exists($predir))
    mkdir($predir, 0700);

// un po' di informazioni di debug
if ($debug)
echo
    "ACTION = $action<br />" .
    "TIPOALLEGATO = $tipoallegato<br />" .
    "ATTACHGROUP = $attachgroup<br />" .
    "ATTACHTEXT = $attachext<br />" .
    "MAXFSIZE = $maxfsize<br />" .
    "PREDIR = $predir<br />" .
    "CREATEGROUP = $_POST[create_new_group]<br />";

if (!isset ($visua_num) or $visua_num == '') {
    $visua_num = 15; 
    $visua = true;
}

if (isset($_POST['bOverwriteAttachFile'])) {

    $doldid = $_POST['double_name_old_id'];
    $dnewid = $_POST['double_name_last_id'];

    if (is_numeric($doldid) && is_numeric($dnewid) && $doldid && $dnewid) {

        $dbquery = "SELECT `size` FROM `allegati` WHERE `id_allegato` = '" . $dnewid . "' LIMIT 1";
        $rs = $connh->Execute($dbquery) or die("ERROR: <br />" . $connh->ErrorMsg());

        if ($rs && $rs->RecordCount())
            $dsize = $rs->fields('size');

        $dbquery = "DELETE FROM `allegati` WHERE id_allegato = '" . $dnewid . "' LIMIT 1";
        $connh->Execute($dbquery) or die("ERROR: <br />" . $connh->ErrorMsg());

        $dbquery = "UPDATE `allegati` SET `size` = '" . $dsize . "' WHERE `id_allegato` = '" . $doldid . "'";
        $connh->Execute($dbquery) or die("ERROR: <br />" . $connh->ErrorMsg());

        if (trim($_POST['double_name_group_name']) != '')
            $double_group_part = "/" . $_POST['double_name_group_name'];
        else
            $double_group_part = '';

        $double_predir = PRISCILLA_LOCAL_PATH . "attach/".$_COOKIE['login']."/$tipoallegato" . $double_group_part;

        $drstatus =
                rename(
                    $double_predir . "/" . $_POST['double_name_last_name'],
                    $double_predir . "/" . $_POST['double_name_old_name']
                );
    } // if (is_numeric
} // if (isset


if ($group_error)
    $upmsg = dialog_att_group_error;


if (isset($upattachfile) && !$group_error) { 

    $upattachfile_size = $_FILES["upattachfile"]["size"];
    $upattachfile_name = $_FILES["upattachfile"]["name"];

    if ($debug)
        echo
            "FILENAME = $upattachfile_name<br />" .
            "FILESIZE = $upattachfile_size<br />";

    if ($upattachfile_size == 0 || $upattachfile_size > $maxfsize)
    $upmsg = dialog_gen_size . ": " .  dialog_upl_nok;
    else {
    $upfilename = strtolower($upattachfile_name);

    if (strstr($upfilename, '.')) {
        $l = strlen($upfilename);
        $realext = "";
        for ($q = $l - 1; $q > -1; $q--) {
        if ($upfilename{$q} == '.') {
            $prename = substr($upfilename, 0, $q);
            $upfilename = str_replace(".", "_", $prename) . "." . $realext;
            break;
        }
        else $realext = $upfilename{$q} . $realext;
        }
    }
    
    $have_a_double_name = false;
    $double_name_message = "";

    // una passata al nome
    $upfilename = ereg_replace("[/\\]'", '_', $upfilename);

    if (!ereg('^\.', $upfilename) && ereg($attachext, $upfilename) && !ereg($attachext_denied, $upfilename) && strlen($upfilename) < ATTACH_MAX_NAME_LENGTH) {

        if (file_exists($predir . "/" . $upfilename)) {

            $double_name_initial = $upfilename;
            $upfilename = time() . "_" . $upfilename;       
            $have_a_double_name = true;

            // l'id del vecchio file
            $dbquery = "SELECT id_allegato FROM `allegati` WHERE `nome` = '" . $double_name_initial  . "' AND `gruppo` = '" . $attachgroup . "' AND `tipo` = '" . $tipoallegato . "' AND `id_user` = '".$_COOKIE['login']."'"; 

            $rs = $connh->Execute($dbquery) or die ("ERROR: " . $dbquery . "<br />" . $connh->ErrorMsg());

            if ($rs->RecordCount() == 1)
                $double_name_old_id = $rs->fields('id_allegato');
            // altrimenti non ne abbiamo o ne abbiamo troppi...
            else
                $have_a_double_name = false;
        }
                
        if (copy("$upattachfile", $predir . "/" . $upfilename)) {
        $myfilesize = filesize($predir . "/" . $upfilename);

        $newcode = generate_new_code ($connh, ATTACH_TABLE_NAME, ATTACH_FIELD_ID, ATTACH_FIELD_CODE);
 
        $dbquery =
            "INSERT INTO " . ATTACH_TABLE_NAME .
            " (id_user, nome, gruppo, tipo, size, description, code) VALUES ('".$_COOKIE['login']."', '$upfilename', '$attachgroup', '$tipoallegato', '$myfilesize', '$_POST[description]', '$newcode')";
                $connh->Execute($dbquery) or die("ERROR:$dbquery<br />".$connh->ErrorMsg());

                $double_name_last_id = $connh->Insert_ID();
                $double_name_message = sprintf(dialog_att_doublename_message, $upfilename, $double_name_initial);

                $upmsg = dialog_upl_ok;
        }
        else $upmsg = "UPLOAD ERROR: could not write to destination dir"; 
        }
        else {
            $upmsg = dialog_upl_nosup;
            if (strlen($upfilename) >= ATTACH_MAX_NAME_LENGTH)
                $upmsg .= " [NAME LENGTH ERROR]";
        }
    } // else
} // if (isset($upattachfile


if($action=='elimina' && !isset($_POST['fromopzioni'])) {

        // prendiamo prima le info che c'interessano
        $dbquery = "SELECT * FROM " . ATTACH_TABLE_NAME . " WHERE id_allegato = '$id'";
        $rowrs = $connh->Execute($dbquery) or die("ERROR:$dbquery<br />".$connh->ErrorMsg());

        if (! $rowrs->RecordCount())
                die("Error: file (id = $id_allegato) not found!");
        else {
                $row = $rowrs->fields;
                $filename = $predir . "/" . $row[nome];
        }
                                
        // cancellazione allegato in tabella...
        $dbquery = "DELETE FROM " . ATTACH_TABLE_NAME . " WHERE id_allegato = '$id'";
        $connh->Execute($dbquery) or die("ERROR:$dbquery<br />".$connh->ErrorMsg());
        
        // ... e da filesystem
        unlink($filename);

    // se siamo nel caso di un gruppo vuoto eliminiamo la cartella

    $where_clause = " WHERE id_user = '".$_COOKIE['login']."' AND tipo = '$tipoallegato' AND gruppo = '$attachgroup'";


    if (trim($attachgroup) != '') {
        $dbquery = "SELECT id_allegato FROM " . ATTACH_TABLE_NAME . $where_clause;
        $rowrs = $connh->Execute($dbquery) or die("ERROR:$dbquery<br />".$connh->ErrorMsg());
        if ($rowrs->RecordCount() <= 0) {
        if (file_exists($predir) && is_dir($predir)) {
            if ($debug)
            echo "Remove $predir<br /><br />";
            rmdir($predir);
            $PRISCILLA_SESSION->add('attach_group', DEFAULT_ATTACH_GROUP);
            $attachgroup = DEFAULT_ATTACH_GROUP;
        }
        }
    }
        $action='';
}

        include PRISCILLA_LOCAL_PATH."adm/include/html_head.inc.php";
        print "</a><title>".dialog_vid_tit."</title>";
        print "<link rel=\"stylesheet\" type=\"text/css\" href=\"" . PRISCILLA_SERVER_PATH . "adm/skin/$skin/default.css\">";
        print "<!--[if lte IE 7]>
			<link rel=\"stylesheet\" type=\"text/css\" href=\"".PRISCILLA_SERVER_PATH."adm/skin/ie6.css\" />
		<![endif]-->";
        print "</head>";
        include PRISCILLA_LOCAL_PATH . "adm/skin/$skin/body.inc";
        include PRISCILLA_LOCAL_PATH . "adm/include/head_popup.inc.php";
?>

<table align="center" class="table_border" width="<? include PRISCILLA_LOCAL_PATH . "adm/include/dim_all.inc.php"; ?>" cellpadding="3" cellspacing="1" border="0">
<tr>
    <th class="table_tit"><? print $attach_title[$tipoallegato]; ?></th>
</tr><tr>
    <td class="table_sez"><? print dialog_att_maxsize . " " . $maxsize_mb; ?></td>
</tr><tr>
<form name="fupload" enctype="multipart/form-data" method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>">
<input type="hidden" name="MAX_FILE_SIZE" value="<?php echo $maxfsize; ?>">
    <td class="insert_voice" align="center">
    <input class="insert_area" type="file" name="upattachfile" size="50" /><br />
</tr><tr>
    <td class="table_sez" align="CENTER">
<?php
    echo "<label for=\"attach_group\">&nbsp;&nbsp;".dialog_att_group.":&nbsp;</label>";
    output_select_group ("attach_group", $attachgroup, $_COOKIE['login'], $connh, $tipoallegato);
    echo
        "<label for=\"create_new_group\">&nbsp;&nbsp;".dialog_att_newgroup.":&nbsp;</label>" .
        "<input size=\"20\" maxlength=\"20\" class=\"insert_area\" type=\"TEXT\" name=\"create_new_group\">\n";
?></td>
</tr><tr>
    <td width="100%" class="insert_voice"><label for="description"><?php echo dialog_att_group_description; ?></label>:<br />
    <textarea class="insert_area" rows="2" name="description" style="width:100%"></textarea></td>
</tr><tr>
    <td align="center" class="button_out">
    <input class="button_in awesome" type="submit" name="action" value="&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<? print dialog_but_send; ?>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"></td>
</form></tr>
<?php

if($upmsg)
    echo "<tr><td align=\"center\" colspan=\"4\" class=\"insert_message\"><strong>$upmsg</strong></td></tr>";
if ($have_a_double_name && $double_name_message != '')

    echo
        "<tr><td class=\"button_out\" align=\"center\" colspan=\"4\" class=\"insert_message\">\n" .
        "<form name=\"overwrite_attach_file\" method=\"post\" action=\"" . $_SERVER['PHP_SELF'] . "\" >\n" .
        "<input type=\"hidden\" name=\"double_name_old_id\" value=\"" . $double_name_old_id . "\" />\n" .
        "<input type=\"hidden\" name=\"double_name_last_id\" value=\"" . $double_name_last_id . "\" />\n" .
        "<input type=\"hidden\" name=\"double_name_old_name\" value=\"" . $double_name_initial . "\" />\n" .
        "<input type=\"hidden\" name=\"double_name_last_name\" value=\"" . $upfilename . "\" />\n" .
        "<input type=\"hidden\" name=\"double_name_group_name\" value=\"" . $attachgroup . "\" />\n" .
        $double_name_message .
        "&nbsp;&nbsp;&nbsp;<input class=\"button_in awesome\" type=\"submit\" name=\"bOverwriteAttachFile\" value=\"" .
        dialog_att_button_overwrite_file .
        "\" />\n" .
        "</form>\n" .
        "</td></tr>\n";
?>



</table><br />

<table class="table_border" width="<? include PRISCILLA_LOCAL_PATH."adm/include/dim_all.inc.php"; ?>" align="center" cellpadding="3" cellspacing="1" border="0">
<tr>
    <th colspan="4" class="table_tit"><? print dialog_img_opt_tt; ?></th>
</tr><tr>
    <form name="fopzioni" method="post">
    <input type="hidden" name="visua" value="true" />
    <input type="hidden" name="fromopzioni" value="ok" />
    <td width="25%" align="center" class="insert_voice">
    <input class="insert_area" type="text" name="visua_num" value="<?php if (isset($visua_num) and $visua_num!='') echo $visua_num; else echo "15";?>" size="4"><br /><label for="visua_num"><? print dialog_img_opt_rpag; ?></label></td>
    <td width="25%" align="center" class="insert_voice"><input class="insert_area" type="text" name="visua_int" size="4" /><br /><label for="visua_int"><? print dialog_img_opt_iint; ?></label></td>
    <td width="25%" align="center" class="insert_voice"><input type="radio" name="visua_all" value="all" /><br /><label for="visua_all"><? print dialog_img_opt_view; ?></label></td><td width="25%" align="CENTER" class="insert_voice">
<?php
    output_select_group ("attach_select", $attachgroup, $_COOKIE['login'], $connh, $tipoallegato);
    echo "<br /><label for=\"attach_select\">".dialog_att_group_select."</label>";
?>
    </td>
    </tr><tr>
    <td colspan="4" align="center" class="button_out"><input type="submit" value="&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<? print dialog_but_app_opt; ?>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" class="button_in awesome"></td>
</tr></form></table>
<br />

<?php

// variabili di controllo del nome buono...

$doublename = 0;
$errorname = 0;
$err_groupname = 0;
$errmsg = '';

// funzione di check nome valido

function is_a_good_filename ($filename) {
    if (!(ereg("^([[:alnum:]_ -]{1,})$", $filename)))
        return 0;
    else return 1;
}

// rinomina allegato
if ($action == "save_indb") {

    if (!isset($attach_id) || !is_numeric ($attach_id))
        die("Fatal Error: invalid ID (id = $attach_id)\n");

    if (!isset($attach_name) || $attach_name == "" || strlen($attach_name) > 60) {
        $id = $attach_id;               
        $action = 'modifica';
        $errorname = 1;
        $errmsg = err_bad_name;        
    }

    if (!$errorname && !is_a_good_filename($attach_name)) {
        $id = $attach_id;
        $action = 'modifica';
        $errorname = 1;
        $errmsg = err_bad_name;
    }
    else if (! $errorname) {

        // poich&eacute; ci fidiamo... andiamo a prendere la vecchia estensione
        
        $dbquery = "SELECT * FROM allegati WHERE id_allegato = '$attach_id'";
        $rowrs = $connh->Execute($dbquery) or die("ERROR:$dbquery<br />".$connh->ErrorMsg());
        if (! $rowrs->RecordCount())
            die("Fatal Error: ID (id = $attach_id) not found!\n");          
        $row = $rowrs->fields;
        $oldname = $row['nome'];

        $oldgruppo = $row['gruppo'];        
        
        if (!strstr($oldname, ".")) {
            $oldext = "";
            $newname = $attach_name;    
        }
        else {
            $oldext = substr($oldname, strpos($oldname, ".") + 1);
            $newname = $attach_name . "." . $oldext;
        }

        // questo elimina parecchie storie
        $newname = strtolower($newname);

        // verifica che il nome non sia gia' esistente in DB
        $dbquery = "SELECT * FROM allegati WHERE gruppo = '$POST[attach_savegroup]' AND nome = '$newname' AND tipo = '$tipoallegato' AND id_user = '".$_COOKIE['login']."'";
        $rowrs = $connh->Execute($dbquery) or die("ERROR:$dbquery<br />".$connh->ErrorMsg());
        
        if ($rowrs->RecordCount() > 0) {

            if ($rowrs->RecordCount() == 1 && $rowrs->fields('id_allegato') == $attach_id)
                $action = '';
            else {
                $id = $attach_id;
                $action = 'modifica';
                $doublename = 1;
                $errmsg = err_double_name;
            }
        
        } else {
        
            // rinominiamo fisicamente il file
            
            $oldpathfile = $predir . "/" . $oldname;
            $newpathfile = $predir . "/" . $newname;
            
            if (!file_exists($oldpathfile))
                die("Fatal Error: file not found (\"$oldpathfile\")\n");
            else if (! rename($oldpathfile, $newpathfile))
                die("Fatal error: could not rename \"$oldpathfile\" to \"$newpathfile\"\n");

            // salviamo le modifiche di nome
            $dbquery = "UPDATE allegati SET nome = '$newname' WHERE id_allegato = '$attach_id'";
            $rowrs = $connh->Execute($dbquery) or die("ERROR:$dbquery<br />" . $connh->ErrorMsg());
                
            $action = '';
        }


        if ($debug)     
            echo
            "<br />newname = $newname<br />id = $attach_id<br />descrizione = $_POST[attach_description]<br />gruppo = $_POST[attach_savegroup]<br />";
            

        // salva altre impostazioni ed eventuale cambio gruppo
        $dbquery = "UPDATE " . 
            ATTACH_TABLE_NAME . " SET description = '$_POST[attach_description]' WHERE id_allegato = '$attach_id'";
        $rowrs = $connh->Execute($dbquery) or die("ERROR:$dbquery<br />" . $connh->ErrorMsg());
        
        $action = '';

        if ($_POST[attach_savegroup] != $oldgruppo) {
            if ($debug)
            echo "gruppo cambia da $oldgruppo a $_POST[attach_savegroup]<br /><br />";

            // vediamo se esite gia' questo nome file nel gruppo di destinazione
            $dbquery = "SELECT id_allegato FROM " . ATTACH_TABLE_NAME . " WHERE gruppo = '$_POST[attach_savegroup]' AND nome = '$newname' AND tipo = '$tipoallegato' AND id_user = '".$_COOKIE['login']."'";
            $rowrs = $connh->Execute($dbquery) or die("ERROR:$dbquery<br />".$connh->ErrorMsg());
            
            if ($rowrs->RecordCount() > 0) {
            $err_groupmove = 1;
            $errmsg = dialog_att_group_doublename; 
            } else {

            // aggiorno il nome del gruppo
            $dbquery = "UPDATE " . 
                ATTACH_TABLE_NAME . " SET gruppo = '$_POST[attach_savegroup]' WHERE id_allegato = '$attach_id'";
            $rowrs = $connh->Execute($dbquery) or die("ERROR:$dbquery<br />" . $connh->ErrorMsg());
                      
            $fromfile = $predir . "/" . $newname;
 
            if (trim($_POST['attach_savegroup']) == '')
                $tofile = "attach/".$_COOKIE['login']."/$tipoallegato" . "/" . $newname;
            else
                $tofile = "attach/".$_COOKIE['login']."/$tipoallegato/$_POST[attach_savegroup]" . "/" . $newname;

            if ($debug)
                echo "fromfile = $fromfile || tofile = $tofile<br />";

            rename($fromfile, $tofile);


            // verifica se sono a zero gli allegati del gruppo da cui si &Egrave; spostatp

            $where_clause = " WHERE id_user = '".$_COOKIE['login']."' AND tipo = '$tipoallegato' AND gruppo = '$oldgruppo'";
    
            if (trim($oldgruppo) != '') {
                $dbquery = "SELECT id_allegato FROM " . ATTACH_TABLE_NAME . $where_clause;
                $rowrs = $connh->Execute($dbquery) or die("ERROR:$dbquery<br />".$connh->ErrorMsg());
                if ($rowrs->RecordCount() <= 0) {
                if (file_exists($predir) && is_dir($predir)) {
                    if ($debug)
                    echo "Remove $predir<br /><br />";
                    rmdir($predir);
                    $PRISCILLA_SESSION->add('attach_group', DEFAULT_ATTACH_GROUP);
                } // if (file_exists
                } // if ($rowrs->RecordCount
            } // if (trim($oldgruppo
            } 
        }
    }// qui si lavora   
} // action save_indb       


// pannello per rinominare gli allegati

if ($action == "modifica" && !isset($_POST['fromopzioni'])) {

    $dbquery = "SELECT * FROM allegati WHERE id_allegato = '$id'";
    $rowrs = $connh->Execute($dbquery) or die("ERROR:$dbquery<br />".$connh->ErrorMsg());

    if (! $rowrs->RecordCount())
        die("Error: file (id = $id) not found!");
    else {
        $row = $rowrs->fields;
        $oldname = $row[nome];
        
        if (! strstr($oldname, "."))
            $nudename = $oldname;
        else
            $nudename = substr($oldname, 0, strpos($oldname, "."));
        
        $modifyname = $nudename;
    }
    

    echo
        "<table class=\"table_border\" width=\"95%\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" align=\"center\">
        <form method=\"post\" name=\"fmodificaitem\">
        <input type=\"hidden\" name=\"ascdesc\" value=\"$ascdesc\">
        <input type=\"hidden\" name=\"orderby\" value=\"$orderby\">";
        
    if ($errorname || $doublename) {
        $modifyname = $attach_name;
        
        if ($errmsg != '')
            echo "\n<tr><td align=\"center\" colspan=\"4\" class=\"insert_message\"><strong>$errmsg</strong></td></tr>\n";
    }
    echo "<tr>
            <th colspan=\"4\" class=\"table_tit\">".dialog_gen_tt_rename." <span class=\"insert_message\">$nudename</span></th>
        </tr>
      <tr>
        <th class=\"table_sez\"><span class=\"insert_message\">".dialog_gen_id."</span></th>
        <th class=\"table_sez\"><label for=\"attach_savegroup\">" . strtoupper(dialog_att_group_select) . "</label></th>
        <th class=\"table_sez\"><label for=\"attach_name\">".dialog_gen_name."</label></th>
        <th class=\"table_sez\"><label for=\"attach_description\">" . strtoupper(dialog_att_group_description) . "</label></th>
      </tr><tr>
        <td width=\"5%\" align=\"center\" class=\"table_id\">$row[id_allegato]</td>
        <td width=\"20%\" align=\"center\" class=\"table_sez\">";
        output_select_group ("attach_savegroup", $row['gruppo'], $_COOKIE['login'], $connh, $tipoallegato);
      echo "</td>
        <td width=\"25%\" align=\"center\" class=\"insert_voice\">
        <input class=\"insert_area\" type=\"text\" name=\"attach_name\" value=\"$modifyname\" style=\"width:100%\"></td>
        <td width=\"50%\" align=\"CENTER\" class=\"insert_voice\">
        <input class=\"insert_area\" type=\"TEXT\" name=\"attach_description\" value=\"" . htmlentities($row[description], ENT_COMPAT, PRISCILLA_CHARSET) . "\" style=\"width:100%\">
        </td>
      </tr>
      <input type=\"hidden\" name=\"visua_num\" value=\"$visua_num\">
      <input type=\"hidden\" name=\"visua\" value=\"true\">";
    echo
        "<tr>
        <td colspan=\"4\"  align=\"center\" class=\"button_out\">
            <input class=\"button_in awesome\" type=\"submit\" value=\"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;".dialog_but_smdb."&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\">
            <input type=\"hidden\" name=\"attach_id\" value=\"$row[id_allegato]\">
            <input type=\"hidden\" name=\"action\" value=\"save_indb\"></td>
        </tr></form></table><br />";
        
    $action = '';
}


    if ($errmsg != '' && $err_groupmove)
    echo "\n<div align=\"CENTER\" class=\"insert_message\"><strong>$errmsg</strong></div><br />\n";


$visua_param = param_to_get($_GET);

if ($visua_param == '') $visua_param = param_to_get($_POST);

if (!isset($orderby) || $orderby == "") $orderby = "id_allegato";
if ($ascdesc == "desc") $ascdesc = "asc";
else $ascdesc = "desc";
if ($uploadok) $ascdesc = "asc";
$condizione = "WHERE id_user = '".$_COOKIE['login']."' AND tipo = '$tipoallegato' AND gruppo = '$attachgroup'";

$dbquery = "SELECT COUNT(id_allegato) as nrow FROM allegati $condizione ORDER BY id_allegato";

$rowrs = $connh->Execute($dbquery);

$nrow_row = $rowrs->fields;
$nrow = $nrow_row[nrow];
$npag = ceil($nrow/$visua_num);


?>

<table align="center" class="table_border" width="<? include PRISCILLA_LOCAL_PATH."adm/include/dim_all.inc.php"; ?>" cellpadding="3" cellspacing="1" border="0">

<tr>
    <th colspan="5" class="table_tit"><? print dialog_all_tt_ins_list; ?></th>
    <th colspan="2" class="table_tit">
        <?php print dialog_img_panel_tot." $nrow";
        if ($nrow)
            echo "&nbsp;|&nbsp;<a class=\"tree_mylink\" href=\"att_down.php?tipoallegato=$tipoallegato&gn=$attachgroup\">".dialog_but_attach_save."</a>";
        ?></th>
</tr>
<?php 


echo "
    <tr>
    <th width=\"5%\" class=\"table_sez\"><span class=\"insert_message\">".dialog_gen_id."</span></th>
    <th width=\"25%\" class=\"table_sez\"><a href=\"$currscript?orderby=id_allegato&ascdesc=$ascdesc&$visua_param\" class=\"insert_message\">".dialog_gen_name."</a></th>
    <th width=\"5%\" class=\"table_sez\">".dialog_gen_size."</th>
    <th width=\"5%\" class=\"table_sez\">".dialog_att_click."</th>
    <th width=\"40%\" class=\"table_sez\">" . strtoupper(dialog_att_group_description) .
    "</th>
    <th width=\"20%\" colspan=2 class=\"table_sez\">".dialog_gen_action."</th>
</tr>";

if (isset($visua) and ($visua_num or $visua_all))
{
    if ($visua_all != 'all')
    {
        global $visua_num;
        global $pagina, $count;
        $count=0;
        
        if ($visua_int != '')
        {
            $visua_int2 = (int)($visua_num / 2);            
            $gap = ($visua_num % 2) ? 1 : 0;
            $int1 = $visua_int - $visua_int2;
            $int2 = $visua_int + $visua_int2 + $gap;
                        
            $dbquery = "SELECT * FROM allegati WHERE id_user='".$_COOKIE['login']."' AND tipo = '$tipoallegato' and id_allegato >= $int1 and id_allegato <= $int2 ORDER BY $orderby";

            $rowrs = $connh->Execute($dbquery) or die("ERR: $dbquery".$connh->ErrorMsg());
            while (!$rowrs->EOF)
            {
                $row = $rowrs->fields;
                printrow($row, $connh);
                $rowrs->MoveNext();
            }
        }
        else
        {
            $inizio = 0;
            
            if (isset($pagina) and $pagina > 0)
            {
                if ($pagina > $npag)
                {
                    $pagina = $npag;
                }
                else
                {
                    $inizio = $pagina * $visua_num - $visua_num;
                }
            }
            elseif ($pagina=='ultima')
            {
                $pagina = $npag;
                $inizio = $pagina * $visua_num - $visua_num;
            }
            else
            {
                $pagina = 1;
                $inizio = 0;
            }

            $dbquery = "SELECT * FROM allegati $condizione ORDER BY $orderby $ascdesc LIMIT $inizio, $visua_num";
            $rowrs = $connh->Execute($dbquery);
            while (!$rowrs->EOF)
            {
                $row = $rowrs->fields;
                printrow($row,$connh);
                $rowrs->MoveNext();
            }
            echo "<tr><td colspan=\"7\" class=\"table_link\" align=\"center\">";
            $strinizio = "<a href=\"$currscript?visua=$visua&visua_num=$visua_num&pagina=0\"> <- ".dialog_img_panel_begin." </a> ";
            $strfine = "<a href=\"$currscript?visua=$visua&visua_num=$visua_num&pagina=$npag\"> ".dialog_img_panel_end." -> </a> ";
            $pagina_precedente = $pagina - 1;
            $pagina_seguente   = $pagina + 1;
            if ($pagina_precedente < 1)
            {
            $pagina_precedente = 1;
            }
            else $str1 = "<a href=\"$currscript?visua=$visua&visua_num=$visua_num&pagina=$pagina_precedente\"> &lt;&lt;&lt;</a> ";

            $after = " - ".$visua_num * $pagina;

            if ($pagina_seguente > $npag)
            {
                $pagina_seguente = $npag;
                $after = " - $nrow";
            }
            else $str3 = "<a href=\"$currscript?visua=$visua&visua_num=$visua_num&pagina=$pagina_seguente\"> &gt;&gt;&gt;</a>";

            $str2 = $inizio.$after;

            echo $strinizio.$str1.$str2.$str3.$strfine;
            print "</td></tr>";
        }
    }
    else
    {
        $dbquery = "SELECT * FROM allegati WHERE id_user='".$_COOKIE['login']."' AND tipo = '$tipoallegato' AND gruppo = '$attachgroup' ORDER BY $orderby $ascdesc";
        $rowrs = $connh->Execute($dbquery);
        while (!$rowrs->EOF)
        {
            $row = $rowrs->fields;
            printrow($row,$connh);
            $rowrs->MoveNext();
        }
    }
}

function param_to_get($param)
{
    $str = "";
    foreach ($param as $key=>$val)
    {
        if ($key == "visua" || $key == "visua_num" || $key == "visua_int" || $key == "visua_all")
            $str .= "$key=$val&";
    }
    substr($str, 0, -1);
    return $str;
}

function printrow($row, $connh)
{
    global $visua_num, $lang;
    global $pagina, $count;

    $size = $row[size];
    
    if ($size >= 1024)
//      $visualsize = "Kb " . round($size / 1024);        
    $visualsize = "Kb " . number_format($size / 1024, 2, ",", "");
    else $visualsize = $size;

    if (trim($row['code']) != '')
        $nhits = $row['hits'];
    else
        $nhits = '---';

    echo "<tr>
        <td width=\"5%\" align=center class=\"table_id\"><strong>$row[id_allegato]</strong></td>
        <td width=\"25%\" align=\"CENTER\" class=\"insert_voice\">$row[nome]</td>
        <td width=\"5%\" align=\"CENTER\" class=\"insert_voice\">$visualsize</td>
        <td width=\"5%\" align=\"CENTER\" class=\"insert_voice\">$nhits</td>
        <td width=\"40%\" align=\"CENTER\" class=\"insert_voice\">$row[description]</td>
        <td width=\"10%\" align=\"center\" class=\"table_link\">
        <a href=\"$currscript?id=$row[id_allegato]&action=modifica&visua_num=$visua_num&visua=true&pagina=$pagina\">".dialog_gen_edit."</a></td>
        <td width=\"10%\" align=\"center\" class=\"table_link\">
        <a href=\"$currscript?id=$row[id_allegato]&action=elimina&visua_num=$visua_num&visua=true\">".dialog_gen_del."</a></td>
    </tr>";
}


    echo "</table>\n<br />";
    include (PRISCILLA_LOCAL_PATH . 'adm/include/closewin.js');
?>
<?php
    include(PRISCILLA_LOCAL_PATH . "adm/include/menu_allegati.inc.php");
    include(PRISCILLA_LOCAL_PATH . "adm/include/about_root.inc.php");
?>
</body></html>

