<?php

require_once "modules/ecal/inc/config.inc.php";

/**
 ** tag: ecal_calendar
 ** desc: stampa il calendario
 ** opt: todaysid, id della pagina che raccoglie gli eventi del giorni, default pagina corrente
 ** opt: eventsid, id della pagina che raccoglie gli eventi, default pagina corrente
 ** opt: width, larghezza dell'iframe, default 400
 ** opt: height, altezza dell'iframe, default 225
 **
 ** eg: stampa il calendario e imposta la pagina degli eventi giornalieri e degli eventi a id 17
 ** eg: {ecal_calendar todaysid="67" eventsid="67"}
 **/
function ecal_calendar ($myconnh, $myrow, &$myPRISCILLA_SESSION, $myoptions)
{

    // ritorna semplicemente l'iframe che contiene il calendario
    $w = 400;
    $h = 225;

    if (isset($_GET["id"]) && is_numeric($_GET["id"]) && $_GET["id"] != 0)
        $current_id = $_GET["id"];
    else
        $current_id = 1;

    $todaysid = $current_id;
    $eventsid = $current_id;

    if (isset($myoptions["width"]) && is_numeric($myoptions["width"]))
        $w = $myoptions["width"];

    if (isset($myoptions["height"]) && is_numeric($myoptions["height"]))
        $h = $myoptions["height"];

     if (isset($myoptions["todaysid"]) && is_numeric($myoptions["todaysid"]))
        $todayid = $myoptions["todaysid"];

     if (isset($myoptions["eventsid"]) && is_numeric($myoptions["eventsid"]))
        $eventsid = $myoptions["eventsid"];

    $sw = $w . "px";
    $sh = $h . "px";

    $cal_path = "modules/ecal/lib/cal.php?todaysid=$todaysid&eventsid=$eventsid";
   
 
    $dataz = <<< EOF
        <iframe width=\"$w\" height=\"$h\" frameborder=\"0\" scrolling=\"no\" id="ecalCalendar" name="ecalCalendar" src="$cal_path" style="width:$sw;height:$sh;border:0px;"></iframe>
EOF;



return $dataz;
}

/**
 ** tag: ecal_date
 ** desc: stampa in data umana (formato: dd-mm-aaaa) che arriva via GET dal parametro cal_i
 ** opt:
 **
 ** eg: {ecal_date}
 **/
function ecal_date ($myconnh, $myrow, &$myPRISCILLA_SESSION, $myoptions)
{
	if (isset($_GET["cal_i"])) {
		$a_d = explode("-", $_GET["cal_i"]);
		return $a_d[2] . "-" . $a_d[1] . "-" . $a_d[0];
	}
}

?>
