<?
//require_once PRISCILLA_LOCAL_PATH . "adm/lib/nusoap.php";

    ini_set("soap.wsdl_cache_enabled", "0");

    $serverpath = PRISCILLA_UPDATE_MIRROR."soapservices.php";
    if ($debug) {
        outdbg("connect to: ".$serverpath);
        $opt = array(
            'location' => $serverpath,
            'uri' => $serverpath,
            'trace' => 1
        );
    }
    else
        $opt = array(
            'location' => $serverpath,
            'uri' => $serverpath
        );

    $client = new SoapClient(null, $opt);

    try {
        $last_version = $client->get_last_version("priscilla3");
    } catch (SoapFault $exception) {
        die($exception->faultstring);
    }

    if ($debug)
        outdbg("call get_last_version".
               "\nrequest ".$client ->__getLastRequest().
               "response ".$client ->__getLastResponse());

    function get_local_version($connh)
    {
        $query = "SELECT versione FROM priscilla";
        $rs = $connh->Execute($query) or die("ERROR: $query<br />".$connh->ErrorMsg());
        $row = $rs->fields;
        return $row[versione];
    }

    function get_local_files($dir)
    {
        global $remote_files, $local_files, $count_path, $debug;
        if ($debug) echo "<br />looking for dir $dir ...";
        $handle = @opendir($dir);
        while ($file = @readdir($handle))
        {
            if (!ereg('^\.', $file))
            {
                $tempDir = $dir."/".$file;
                if (is_dir($tempDir))
                {
                    get_local_files($tempDir);
                }
                else
                {
                    $tempFile = substr_replace($tempDir, "", 0, $count_path);
                    $f = array_key_exists($tempFile, $remote_files); // se e' un file i distribuzione
                    if ($f)
                    {
                        if ($debug) echo "<br />file $tempFile is a distribution file";
                        $local_files[$tempFile] = md5_file(PRISCILLA_LOCAL_PATH . $tempFile);
                    }
                }
            }
        }
        closedir($handle);
        return $local_files;
    }

    $local_version = get_local_version($connh);

    try {
        $comment_last_version = $client->get_comment_last_version("priscilla3", $local_version);
    } catch (SoapFault $exception) {
        die($exception->faultstring);
    }

    if ($debug)
        outdbg("call get_comment_last_version".
               "\nrequest ".$client ->__getLastRequest().
               "response ".$client ->__getLastResponse());

    echo "<br /><br /><span style=\"color:navy;font-size:1.8em;\"><strong>" . adm_update_tt_localver . ":" . $local_version;
    echo "<br />" . adm_update_tt_lastver . ":" . $last_version . "</strong></span>";
    echo "<br /><br /><strong>" . adm_update_tt_lastver_warning . "</strong></td></tr></table>";
    echo "<table align=\"center\" class=\"table_border\" cellpadding=\"7\" cellspacing=\"1\" border=\"0\"><tr><td align=\"center\" valign=\"top\" class=\"insert_voice\">$comment_last_version</td></tr></table>";


    if (!isset($_POST['update_username']) && !isset($_POST['update_password'])) {
        echo "<br /><table width=\"100%\" align=\"center\" class=\"table_border\" cellpadding=\"4\" cellspacing=\"1\" border=\"0\"><tr><td width=\"50%\" align=\"center\" class=\"button_out\">
        <form method=\"post\"><input class=\"insert_voice\" type=\"text\" name=\"update_username\"><br />" . adm_voice_uid . "</td>";
        echo "<td width=\"50%\" class=\"button_out\" align=\"center\"><input class=\"insert_voice\" type=\"password\" name=\"update_password\"><br />" . adm_voice_pwd . "</td>
        </tr>";
        echo "<tr><td colspan=\"2\" class=\"insert_voice\"><em>" .
             adm_update_tt_getuserpass .
            "</em></td></tr>
        <tr><td colspan=\"2\" class=\"button_out\" align=\"center\">
        <input class=\"button_in awesome\" type=\"submit\" value=\"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;!!! " . adm_update_but_activate . " !!!&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\"></form></td></tr></table>";
    }

    // ----- CLIENT_AUTH
    else //(isset($update_username) && isset($update_password))
    {

        $mandragora_cookie = "./lib/mandragora_was_here.php";

        // si testa la presenza di mandragora
        // ottenendo il servizio locale cui chiedere autorizzazione

        if (file_exists($mandragora_cookie) && is_readable($mandragora_cookie)) {
            $login_failed = true;
            $mandragora_login_error = "UNKNOWN ERROR";

            $mandragora_cookie_content = file ($mandragora_cookie);
            $mandragora_get_auth_path = $mandragora_cookie_content[0];

            $update_ppath = PRISCILLA_LOCAL_PATH;


            if ($update_ppath{strlen($update_ppath) - 1} == '/')
                $update_ppath = substr($update_ppath, 0, -1);

            $client = new soapclient($mandragora_get_auth_path);

            if ($fault = $client->getError())
                $mandragora_login_error =  $fault;
            else {
                $auth_param = array(
                    "priscilla_path" => $update_ppath,
                    "username" => $update_username,
                    "password" => $update_password,
                    "clientip" => $_SERVER['REMOTE_ADDR']
                );
    
                $rres = $client->call("mandragora_get_auth", $auth_param);
    
                if ($fault = $client->getError())
                    $mandragora_login_error =  $fault;
                else {
                    $login_failed = false;
                    $user_pass = explode(':', $rres);
                    $update_username = $user_pass[0];
                    $update_password = $user_pass[1];
                }
                unset($auth_param);
                unset($client);
            }
        } // if (file_exists


        if (isset($login_failed) && $login_failed) {
            die("<br /><br /><span style=\"color:red\"><strong>" . "LOGIN ERROR: " . $mandragora_login_error . "</strong></span><br /><br />\n");
        }

        try {
            $auth_result_return = $client->client_auth("priscilla3", $_POST['update_username'], $_POST['update_password'], $_SERVER['REMOTE_ADDR']);
        } catch (SoapFault $exception) {
            die($exception->faultstring);
        }
    
        if ($debug)
            outdbg("call client_auth".
                "\nrequest ".$client ->__getLastRequest().
                "response ".$client ->__getLastResponse());

        
        // si salva il restituito cookie di autenticazione
        $adms_cookie = $auth_result_return['return_key'];

        echo "<br />" . adm_update_msg_auth_ok . "<br /><br />";
        //************** CONTROLLO DEL DATABASE *******************
        echo "<br /><br />" . adm_update_tt_dbcheck_running . "...";
        flush();

        // ---- GET PROJECT INFO
        try {
            $project_info = $client->get_project_info("priscilla3");
        } catch (SoapFault $exception) {
            die($exception->faultstring);
        }
    
        if ($debug)
            outdbg("call get_project_info".
                "\nrequest ".$client ->__getLastRequest().
                "response ".$client ->__getLastResponse());

        //$project_info = unserialize($client->call("get_project_info", $param));

        $update_table_format = $project_info['table_format'];
        if (trim($update_table_format) == '')
            $update_table_format = "MyISAM";
    

        //prendo la stringa serializzata nel server
        try {
            $remote_obj = $client->get_db("priscilla3", $last_version, $_POST['update_username'], $adms_cookie);
        } catch (SoapFault $exception) {
            die($exception->faultstring);
        }
    
        if ($debug)
            outdbg("call get_db".
                "\nrequest ".$client ->__getLastRequest().
                "response ".$client ->__getLastResponse());

        //ritrasformo i dati del db
        //$remote_obj = stripslashes($remote_obj);
        //$remote_obj = unserialize($remote_obj);
        
        require PRISCILLA_LOCAL_PATH . "modules/update/lib/update_db.inc.php";

        echo "<br />" . adm_update_tt_dbcheck_compl;
        flush();

        // ----- GET_ALL_FILES
        try {
            $remote_files = unserialize($client->get_all_files_md5(SW_NAME, $last_version, $_POST['update_username'], $adms_cookie));
        } catch (SoapFault $exception) {
            die($exception->faultstring);
        }
    
        if ($debug)
            outdbg("call get_all_files_md5".
                "\nrequest ".$client ->__getLastRequest().
                "response ".$client ->__getLastResponse());

        $count_path = strlen(PRISCILLA_LOCAL_PATH) + 1;
        $local_files = array();
        $local_files = get_local_files(PRISCILLA_LOCAL_PATH, $remote_files);
        $new_files = array_diff(array_keys($remote_files), array_keys($local_files));

        foreach ($new_files as $val)
        {
            echo "<br />".PRISCILLA_LOCAL_PATH." + <strong>$val</strong> " . adm_update_tt_to_create_file;
            if (!file_exists(PRISCILLA_LOCAL_PATH.$val))
                if (!@touch(PRISCILLA_LOCAL_PATH.$val))
                {
                    $regsval = explode("/",$val);
                    $dirlevel = count($regsval);
                    $tmppath = PRISCILLA_LOCAL_PATH;
                    $tmpcounter = 0;
                    foreach ($regsval as $val)
                    {
                        if ($tmpcounter == $dirlevel) // e' l'ultimo pezzo => file
                        {
                            if (@touch($tmppath))
                                echo ".... " . adm_update_tt_file_created;
                            else
                                echo "<br />" . adm_update_err_file_create . " " . $tmppath;
                        }
                        else
                        {
                            if (!file_exists($tmppath))
                            {
                                if (!@mkdir($tmppath,0700)) // e' per forza una dir
                                {
                                    echo "<br />" . adm_update_err_dir_create . " " . $tmppath;
                                }
                                else if ($debug) echo ".... " . adm_update_tt_dir_created . " " . $tmppath;
                            }
                            $tmppath .= $val."/";
                        }
                        $tmpcounter++;
                    }
                }
                else echo ".... " . adm_update_tt_file_created;
        }

        $local_files = array_diff_assoc($remote_files, $local_files);

        // pezza per diff_assoc manuale
        if (!is_array($local_files))
        $local_files = array();

        if ($debug) {
            outdbg("<h1>File da modificare</h1><pre>" .
            print_r($local_files, false) . 
            "</pre>");
        }

        $tot_local = count($local_files);
        $c = 0;
        foreach ($local_files as $key=>$val)
        {
            $c_av++;
            echo "<script type=\"text/javascript\">
            var c;
            c = (200*$c_av)/$tot_local;
            c = Math.round(c);
            document.avanzamento.width = c;
            </script>";

            // ----- UPDATE
            try {
                $remote_content = base64_decode($client->update_file(SW_NAME, $key, $last_version, $_POST['update_username'], $adms_cookie));
            } catch (SoapFault $exception) {
                die($exception->faultstring);
            }
        
            if ($debug)
                outdbg("call get_last_version".
                    "\nrequest ".$client ->__getLastRequest().
                    "response ".$client ->__getLastResponse());

            $fd = @fopen(PRISCILLA_LOCAL_PATH . $key, "wb");
            if (!$fd)
                echo "<br />" . adm_update_err_open . " " . $key;
            $nb = @fwrite($fd, $remote_content);
            if ($debug)
                echo "<br />scritti in " . PRISCILLA_LOCAL_PATH . "$key $nb byte";
            @fclose($fd);
            echo "<br />" . $key . " " .  adm_update_tt_updated;
            flush();
            $c++;
        }

        if ($c == 0) echo "<br />" . adm_update_tt_no_update;
        else echo "<br />" . adm_update_tt_number_updated . ": " . $c;

        //aggiorna il numero di versione
        $query = "UPDATE priscilla SET versione='$last_version'";
        $connh->Execute($query) or die("ERROR: $query<br />".$connh->ErrorMsg());
        echo "<br />" . adm_update_tt_filecheck_compl;

        $modules_to_install = array();
        $moduledir = PRISCILLA_LOCAL_PATH . "modules";
        $vtable_modules_file = PRISCILLA_LOCAL_PATH . "lib/vtable_mod.inc.php";
        $want_output = false;

        $handle = opendir($moduledir);
        while (false !== ($file = readdir($handle)))
            if (!ereg('^\.', $file)) {
                $module_data_dir = PRISCILLA_LOCAL_PATH . "modules/$file/data";
                if (!file_exists($module_data_dir))
                mkdir($module_data_dir, 0700);
                    $modules_to_install[] = $file;
            }
        closedir($handle);

        if (count($modules_to_install))
            create_modules_vtable ($modules_to_install, $moduledir, $vtable_modules_file);

    }

?>